package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.service.BrandService;
import com.gxwebsoft.shop.entity.Brand;
import com.gxwebsoft.shop.param.BrandParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 品牌控制器
 *
 * @author 科技小王子
 * @since 2024-04-04 11:38:21
 */
@Api(tags = "品牌管理")
@RestController
@RequestMapping("/api/shop/brand")
public class BrandController extends BaseController {
    @Resource
    private BrandService brandService;

    @ApiOperation("分页查询品牌")
    @GetMapping("/page")
    public ApiResult<PageResult<Brand>> page(BrandParam param) {
        // 使用关联查询
        return success(brandService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('shop:brand:list')")
    @ApiOperation("查询全部品牌")
    @GetMapping()
    public ApiResult<List<Brand>> list(BrandParam param) {
        // 使用关联查询
        return success(brandService.listRel(param));
    }

    @ApiOperation("根据id查询品牌")
    @GetMapping("/{id}")
    public ApiResult<Brand> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(brandService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('shop:brand:save')")
    @ApiOperation("添加品牌")
    @PostMapping()
    public ApiResult<?> save(@RequestBody Brand brand) {
        // 记录当前登录用户id
        // User loginUser = getLoginUser();
        // if (loginUser != null) {
        //  brand.setUserId(loginUser.getUserId());
        // }
        if (brandService.save(brand)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:brand:update')")
    @ApiOperation("修改品牌")
    @PutMapping()
    public ApiResult<?> update(@RequestBody Brand brand) {
        if (brandService.updateById(brand)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:brand:remove')")
    @ApiOperation("删除品牌")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (brandService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('shop:brand:save')")
    @ApiOperation("批量添加品牌")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<Brand> list) {
        if (brandService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:brand:update')")
    @ApiOperation("批量修改品牌")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<Brand> batchParam) {
        if (batchParam.update(brandService, "brand_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:brand:remove')")
    @ApiOperation("批量删除品牌")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (brandService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
